Subject: Re: [PATCH net-next] igb: reset PHY after recovering from PHY power down

From: Koki Sanagi <[email-masked]>
Date: Mon, 19 Dec 2011 08:59:28 +0900

(2011/12/17 0:53), Wyborny, Carolyn wrote:
> 
> 
>> -----Original Message-----
>> From: Koki Sanagi [mailto:[email-masked]]
>> Sent: Wednesday, November 23, 2011 7:18 PM
>> To: [email-masked]; Kirsher, Jeffrey T; Brandeburg, Jesse;
>> Allan, Bruce W; Wyborny, Carolyn; Skidmore, Donald C; Rose, Gregory V;
>> Waskiewicz Jr, Peter P; Duyck, Alexander H; Ronciak, John; e1000-
>> [email-masked]
>> Cc: [email-masked]
>> Subject: [PATCH net-next] igb: reset PHY after recovering from PHY power
>> down
>>
>> According to 82576_Datasheet.pdf, PHY setting is lost after PHY power
>> down.
>> So resetting PHY is needed when recovering from PHY power down to set a
>> default
>> setting to PHY register.
>>
>> Owing to this lack, NIC doesn't link up in some rare situation.
>> The situation I encountered is following.
>>
>>
>> 1.Both ports connect to switch.
>> +---------+           +--------+
>> |         |-----------|        |
>> | 82576NS |           | switch |
>> |         |-----------|        |
>> +---------+           +--------+
>>
>> 2.Detach both cables from switch.
>> +---------+           +--------+
>> |         |-------    |        |
>> | 82576NS |           | switch |
>> |         |-------    |        |
>> +---------+           +--------+
>>
>> 3.Detach one cable from one port.
>> +---------+           +--------+
>> |         |-------    |        |
>> | 82576NS |           | switch |
>> |         |           |        |
>> +---------+           +--------+
>>
>> 4.Attach that cable to the other port.(It means connecting directly each
>> port)
>> +---------+           +--------+
>> |         |-------+   |        |
>> | 82576NS |       |   | switch |
>> |         |-------+   |        |
>> +---------+           +--------+
>>
>> As a result, NIC doesn't link up sometimes.
>>
>> Signed-off-by: Koki Sanagi <[email-masked]>
>> ---
>> drivers/net/ethernet/intel/igb/igb_main.c |    1 +
>> 1 files changed, 1 insertions(+), 0 deletions(-)
>>
>> diff --git a/drivers/net/ethernet/intel/igb/igb_main.c
>> b/drivers/net/ethernet/intel/igb/igb_main.c
>> index bd9b30e..4d4f065 100644
>> --- a/drivers/net/ethernet/intel/igb/igb_main.c
>> +++ b/drivers/net/ethernet/intel/igb/igb_main.c
>> @@ -2496,6 +2496,7 @@ static int igb_open(struct net_device *netdev)
>> 		goto err_setup_rx;
>>
>> 	igb_power_up_link(adapter);
>> +	igb_reset_phy(hw);
>>
>> 	/* before we allocate an interrupt, we must be ready to handle it.
>> 	 * Setting DEBUG_SHIRQ in the kernel makes it fire an interrupt
> 
> I apologize for the delay in getting back to you.  After a review, I see 
> that the needed change is simpler than I thought at first.  Can you resubmit
> with the igb_reset_phy call being added to the end of the igb_power_up_link 
> function instead of after it in igb_open.  That way, whenever igb_power_link
> is called in the code, it will also execute the igb_reset_phy function which 
> is the complete solution.  Thank you for your work on the igb driver.
> 

Thank you for your reply.

O.K. I'll resubmit it soon.

Thanks!
Koki Sanagi

> Carolyn
> 
> Carolyn Wyborny
> Linux Development
> LAN Access Division
> Intel Corporation
> 
> 
> 
> --
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
> 
>